/*
 * FILE      : lp_lumx.c
 * SYSTEM    : ktAό`Atsgđ^ako
 * FUNCTION  : ktts̗̈mہAA{
 * AUTHOR    : N.Tsuchiya  2000.02.28
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include "lp_ssc.h"
#include "lpvect3.h"
#include "lplufact.h"
#define INFINITE_VALUE 1e30    /* lpengine.hړ NT011011 */

#if !defined(_DEBUG_SSC)  /* CHKÂ߂ɖɂ */
#	undef CHKA
#	undef CHKB
#	undef CHKX
#	undef CHKY
#	define CHKA(x,y,z) (0)
#	define CHKB(x,y,z) (0)
#	define CHKX(x,y,z) (0)
#	define CHKY(x,y,z) (0)
#endif

/*	ID lumx_dump_col	ŝP_v
/*******************************************************************/
static int lumx_dump_col( LUMATRX *a, int j )
{
	int		aa;
	LUAVS	*aav = &a->av;
	Dprintf( "(%d) \n", j ); 
	for( aa = a->col_head[j]; aa >= 0; aa = aav->nexti[aa] ) {
		Dprintf( "    av[%d] (%d)s(%d)l(%g)\n", aa, aav->j[aa], aav->i[aa], aav->v[aa] );
	}
	return 0;
}

/*	ID_lumx_dump_all	s̃_v
/*******************************************************************/
int lumx_dump_all( LUMATRX *a, char *titl )
{
	int		j;
	Dprintf( "%s m(%d)n(%d)n_av(%d) \n", titl, a->n_row, a->n_col, a->n_av ); 
	for( j = 0; j < a->n_col; ++j ) {
		lumx_dump_col( a, j );
	}
	return 0;
}

/*	ID_lu_reset	kAtAqs̏
/*******************************************************************/
int lu_reset( LUFACT *b )
{
	memset( b->lw.pfv, 0, b->sz * sizeof(PFVECT) );
	memset( b->up.pfv, 0, b->sz * sizeof(PFVECT) );
	memset( b->lw.aux, 0, b->sz * sizeof(PFVECT2) );
	memset( b->up.aux, 0, b->sz * sizeof(PFVECT2) );
	memset( b->br.aux, 0, b->sz * sizeof(PFVECT2) );
	b->lw.allendpfv = b->lw.allbgnpfv  = -1;
	b->up.allendpfv = b->up.allbgnpfv  = -1;
	b->br.allendpfv = b->br.allbgnpfv  = -1;

	b->lw.useendpfv = b->lw.usebgnpfv  = -1;
	b->up.useendpfv = b->up.usebgnpfv  = -1;
	b->br.useendpfv = b->br.usebgnpfv  = -1;
	b->lw.useendaux = b->lw.usebgnaux  = -1;
	b->up.useendaux = b->up.usebgnaux  = -1;
	b->br.useendaux = b->br.usebgnaux  = -1;
	b->lw.typev = b->up.typev = 1;
	b->br.typev = 2;
	b->n_br = 0;
	b->ll_nz = 0;     /* ksOvf̐BΊpvf    */
	b->uu_nz = 0;     /* tsOvf̐                   */
/*	for( i = 0; i < b->sz; ++i ) {
/*		b->lw.pfv[i].pf_head = b->up.pfv[i].pf_head = -1;
/*		b->lw.pf_aux_head[i] = b->up.pf_aux_head[i] = b->br.pf_aux_head[i] = -1;
/*	}
*/
/*	memset( b->lw.pf_aux_head, 0, b->sz * sizeof(LUAVS*) );*/
/*	memset( b->up.pf_aux_head, 0, b->sz * sizeof(LUAVS*) );*/
/*	memset( b->br.pf_aux_head, 0, b->sz * sizeof(LUAVS*) );*/
	return 0;
}
/*	ID_lumx_reset	ktO̍s̏
/*******************************************************************/
int lumx_reset( LUMATRX *a /* LUFACT *b */)  /* HY020225 ύX */
{
	int		i;

	/* 擪|C^̏ */
	/* a = b->lu; */
	a->n_av  = 0 ;
	a->num_nz = 0;
	for( i = 0; i < a->n_col; ++i ) {
		a->col_head[i] = -1;
		a->col_nz[i]   = 0;
	}
	for( i = 0; i < a->n_row; ++i ) {
		a->row_head[i] = -1;
		a->row_nz[i]   = 0;
	}
/*	lumx_ini_v(); /* FS020220 */
	return 0;
}
/*	ID_lumx_renew	s̗̈mۂƊg
/*******************************************************************/
int lumx_renew( LUFACT *b,int sz, int x_br, double r_av )
{
	int		rc, m1;
	int		x_row, x_col, x_av;
	int		max_br;
	LUMATRX	*a;
	                       CHKB(0, 0, sz);
#ifdef _DEBUG_SSC
	if(lpdbgf[139])TRACEA(0), Dprintf("lumx_renew sz(%d) \n", sz);
#endif
	/* kt̂kAtAqs̗̈ */
	b->sz = sz;
	b->x_br = x_br;
	max_br = MAXPV;         CHKB(1, 50, MAXPV);
	if( b->x_sz <= 0 ) {  /* VKm */
		if( NULL == (b->br.pfv = (PFVECT*) malloc( max_br*sizeof(PFVECT) )) ) goto erra;
	}
	if( b->x_sz <= 0 ) {  /* VKm */
		if( NULL == (b->lw.pfv = (PFVECT*) malloc((sz+1)*sizeof(PFVECT) )) ) goto erra;
		if( NULL == (b->up.pfv = (PFVECT*) malloc((sz+1)*sizeof(PFVECT) )) ) goto erra;
		if( NULL == (b->lw.aux = (PFVECT2*) malloc((sz+1)*sizeof(PFVECT2) )) ) goto erra;
		if( NULL == (b->up.aux = (PFVECT2*) malloc((sz+1)*sizeof(PFVECT2) )) ) goto erra;
		if( NULL == (b->br.aux = (PFVECT2*) malloc((sz+1)*sizeof(PFVECT2) )) ) goto erra;
/*		if( NULL == (b->lw.pf_aux_head =(LUAVS**)malloc((sz+1)*sizeof(LUAVS*) )) ) goto erra;*/
/*		if( NULL == (b->up.pf_aux_head =(LUAVS**)malloc((sz+1)*sizeof(LUAVS*) )) ) goto erra;*/
/*		if( NULL == (b->br.pf_aux_head =(LUAVS**)malloc((sz+1)*sizeof(LUAVS*) )) ) goto erra;*/
		if( NULL == (b->diag_v = (double *)malloc((sz+1)*sizeof(double) )) ) goto erra;
		if( NULL == (b->ips1   = (int *)   malloc((sz+2)*sizeof(int)   )) ) goto erra;
		if( NULL == (b->ips2   = (int *)   malloc((sz+2)*sizeof(int)   )) ) goto erra;
		b->x_sz = sz+1;
	} else if( b->x_sz < sz ) {
		if( NULL == (Realloc( (void**)&b->lw.pfv,(sz+1)*sizeof(PFVECT) )) ) goto erra;
		if( NULL == (Realloc( (void**)&b->up.pfv,(sz+1)*sizeof(PFVECT) )) ) goto erra;
		if( NULL == (Realloc( (void**)&b->lw.aux,(sz+1)*sizeof(PFVECT2) )) ) goto erra;
		if( NULL == (Realloc( (void**)&b->up.aux,(sz+1)*sizeof(PFVECT2) )) ) goto erra;
		if( NULL == (Realloc( (void**)&b->br.aux,(sz+1)*sizeof(PFVECT2) )) ) goto erra;
/*		if( NULL == (b->lw.pf_aux_head=(LUAVS**)Realloc(b->lw.pf_aux_head,(sz+1)*sizeof(LUAVS*))) ) goto erra;*/
/*		if( NULL == (b->up.pf_aux_head=(LUAVS**)Realloc(b->up.pf_aux_head,(sz+1)*sizeof(LUAVS*))) ) goto erra;*/
/*		if( NULL == (b->br.pf_aux_head=(LUAVS**)Realloc(b->br.pf_aux_head,(sz+1)*sizeof(LUAVS*))) ) goto erra;*/
		if( NULL == (Realloc( (void**)&b->diag_v,(sz+1)*sizeof(double) )) ) goto erra;
		if( NULL == (Realloc( (void**)&b->ips1,(sz+2)*sizeof(int)    )) ) goto erra;
		if( NULL == (Realloc( (void**)&b->ips2,(sz+2)*sizeof(int)    )) ) goto erra;
		b->x_sz = sz+1;
	}
	/* kAtAqs̏ */
	lu_reset( b );
	/* ktO̍s̗̈ */
	a = b->lu;
	if( a == NULL ) {  /* VKm */
		if( NULL == (a = (LUMATRX *)malloc( sizeof(LUMATRX) )) ) goto erra;
		memset( a, 0, sizeof(LUMATRX) );
		b->lu = a;
	}
	a->n_col = sz;
	a->n_row = sz;
	x_row = x_col = sz + 1;
	if( a->x_row <= 0 ) {
		if( NULL == (a->row_nz   = (int*)malloc( x_row * sizeof(int) )) ) goto erra;
		if( NULL == (a->row_head = (int*)malloc( x_row * sizeof(int))) ) goto erra;
		if( NULL == (a->row_k_head =(int*)malloc(x_row * sizeof(int))) ) goto erra;
		if( NULL == (a->rmax_v = (double *)malloc(x_row* sizeof(double))) ) goto erra;
		if( NULL == (a->rmax_f = (int *)   malloc(x_row* sizeof(int)   )) ) goto erra;
		a->x_row = x_row;
	} else if( a->x_row < x_row ) {   /* KvΊg */
		if( NULL == (Realloc( (void**)&a->row_nz  , x_row * sizeof(int) )) ) goto erra;
		if( NULL == (Realloc( (void**)&a->row_head, x_row * sizeof(int))) ) goto erra;
		if( NULL == (Realloc( (void**)&a->row_k_head, x_row * sizeof(int))) ) goto erra;
		if( NULL == (Realloc( (void**)&a->rmax_v,x_row*sizeof(double))) ) goto erra;
		if( NULL == (Realloc( (void**)&a->rmax_f,x_row*sizeof(int)   )) ) goto erra;
		a->x_row = x_row;
	}
	if( a->x_col <= 0 ) {
		if( NULL == (a->col_nz    = (int*)malloc(x_col * sizeof(int) )) ) goto erra;
		if( NULL == (a->col_head  = (int*)malloc(x_col * sizeof(int))) ) goto erra;
		if( NULL == (a->col_k_head =(int*)malloc(x_col * sizeof(int))) ) goto erra;
		if( NULL == (a->cmax_v = (double*)malloc(x_col * sizeof(double))) ) goto erra;
		if( NULL == (a->cmax_f    = (int*)malloc(x_col * sizeof(int)   )) ) goto erra;
		a->x_col = x_col;
	} else if( a->x_col < x_col ) {  /* KvΊg */
		if( NULL == (Realloc((void**)&a->col_nz    ,x_col * sizeof(int) )) ) goto erra;
		if( NULL == (Realloc((void**)&a->col_head  ,x_col * sizeof(int))) ) goto erra;
		if( NULL == (Realloc((void**)&a->col_k_head,x_col * sizeof(int))) ) goto erra;
		if( NULL == (Realloc((void**)&a->cmax_v    ,x_col * sizeof(double))))goto erra;
		if( NULL == (Realloc((void**)&a->cmax_f    ,x_col * sizeof(int) )) ) goto erra;
		a->x_col = x_col;
	}
	/* a->av ̈ HY020625 */
	x_av = (int)(r_av * (double)sz * (double)sz * 2.0);
	if( x_av <= 0 ) x_av = 1;
	if( a->x_av <= 0 ) {
		if( NULL == (a->av.i     = (int*)malloc(x_av * sizeof(int) )) ) goto erra;
		if( NULL == (a->av.j     = (int*)malloc(x_av * sizeof(int) )) ) goto erra;
		if( NULL == (a->av.nexti = (int*)malloc(x_av * sizeof(int) )) ) goto erra;
		if( NULL == (a->av.nextj = (int*)malloc(x_av * sizeof(int) )) ) goto erra;
		if( NULL == (a->av.v  = (double*)malloc(x_av * sizeof(double) )) ) goto erra;
		a->x_av = x_av;
	} else if( a->x_av < x_av ) {  /* KvΊg */
		if( NULL == (Realloc((void**)&a->av.i,    x_av * sizeof(int) )) ) goto erra;
		if( NULL == (Realloc((void**)&a->av.j,    x_av * sizeof(int) )) ) goto erra;
		if( NULL == (Realloc((void**)&a->av.nexti,x_av * sizeof(int) )) ) goto erra;
		if( NULL == (Realloc((void**)&a->av.nextj,x_av * sizeof(int) )) ) goto erra;
		if( NULL == (Realloc((void**)&a->av.v,    x_av * sizeof(double)))) goto erra;
		a->x_av = x_av;
	}
	/* ktO̍s̏ */
/*	lumx_reset( b ); HY020225 */
	lumx_reset( a );
	/* Sktʂ̃[N̈ */
	m1 = sz + 1;
	if( (rc = lpvect2_alloc( &lplu.dalpha, sz, NULL )) < 0 ) goto quit;
	if( (rc = lpvect2_alloc( &lplu.ur, sz, NULL )) < 0 ) goto quit;
	if( lplu.dwk1 == NULL ) {  /* VKm */
		if( NULL == (lplu.dwk1 = (double*)malloc( m1 * sizeof(double))) ) goto erra;
		if( NULL == (lplu.dwk2 = (double*)malloc( m1 * sizeof(double))) ) goto erra;
		if( NULL == (lplu.dwk3 = (double*)malloc( m1 * sizeof(double))) ) goto erra;
		if( NULL == (lplu.aibo=    (int*)malloc( m1 * sizeof(int))) ) goto erra;
		if( NULL == (lplu.mt = (int(*)[2])malloc( 2*2*m1*sizeof(int)))  ) goto erra;
/*		if( NULL == (lplu.ur   = (double*)malloc( m1 * sizeof(double))) ) goto erra; /* */
		if( NULL == (lplu.ips1 =(int *)malloc((m1+2)*sizeof(int   ))) ) goto erra;
		if( NULL == (lplu.ips2 =(int *)malloc((m1+2)*sizeof(int   ))) ) goto erra;
/*  => HY020529 */
#if defined B3_USE
		if( NULL == (lplu.b3.ms   =(MSET*)malloc( m1 * sizeof(MSET  ))) ) goto erra;
		if( NULL == (lplu.b3.pair =(PAIR*)malloc( m1 * sizeof(PAIR  ))) ) goto erra;
		if( NULL == (lplu.b3.list1=(int *)malloc( m1 * sizeof(int   ))) ) goto erra;
		if( NULL == (lplu.b3.list2=(int *)malloc( m1 * sizeof(int   ))) ) goto erra;
		if( NULL == (lplu.b3.sumi1=(int *)malloc( m1 * sizeof(int   ))) ) goto erra;
		if( NULL == (lplu.b3.sumi2=(int *)malloc( m1 * sizeof(int   ))) ) goto erra;
		if( NULL == (lplu.b3.ips1 =(int *)malloc((m1+2)*sizeof(int   ))) ) goto erra;
		if( NULL == (lplu.b3.ips2 =(int *)malloc((m1+2)*sizeof(int   ))) ) goto erra;
		if( NULL == (lplu.b3.frnd=(int*)malloc( m1 * sizeof(int) )) ) goto erra;
#endif //defined B3_USE
/* <= */
	/* HY011217 */
		if( NULL == (lplu.r_nztop=(int *)malloc( m1 * sizeof(int)  )) ) goto erra;
		if( NULL == (lplu.c_nztop=(int *)malloc( m1 * sizeof(int)  )) ) goto erra;
		if( NULL == (lplu.r_nzlst=(NZLST*)malloc( m1 * sizeof(NZLST))) ) goto erra;
		if( NULL == (lplu.c_nzlst=(NZLST*)malloc( m1 * sizeof(NZLST))) ) goto erra;
		lplu.x_sz = m1;  /* sz;  HY020422 */
	} else if( lplu.x_sz < m1 ) {  /* sz -> m1 HY020423 */
		if( NULL == (Realloc((void**)&lplu.dwk1 , m1 * sizeof(double))) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.dwk2 , m1 * sizeof(double))) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.dwk3 , m1 * sizeof(double))) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.aibo, m1 * sizeof(int))) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.mt, 2*2 * m1 * sizeof(int))) ) goto erra;
/*		if( NULL == (lplu.ur   = (double*)Realloc(lplu.ur   , m1 * sizeof(double))) ) goto erra; /* */
		if( NULL == (Realloc((void**)&lplu.ips1,(m1+2)*sizeof(int))) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.ips2,(m1+2)*sizeof(int))) ) goto erra;
/*  => HY020529 */
#if defined B3_USE
		if( NULL == (Realloc((void**)&lplu.b3.ms   ,m1 * sizeof(MSET))) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.b3.pair ,m1 * sizeof(PAIR))) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.b3.list1,m1 * sizeof(int ))) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.b3.list2,m1 * sizeof(int ))) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.b3.sumi1,m1 * sizeof(int ))) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.b3.sumi2,m1 * sizeof(int ))) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.b3.ips1,(m1+2)*sizeof(int))) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.b3.ips2,(m1+2)*sizeof(int))) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.b3.frnd,m1 * sizeof(int))) ) goto erra;
#endif //defined B3_USE
/* <= */
	/* HY011217 */
		if( NULL == (Realloc((void**)&lplu.r_nztop, m1 * sizeof(int)  )) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.c_nztop, m1 * sizeof(int)  )) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.r_nzlst, m1 * sizeof(NZLST))) ) goto erra;
		if( NULL == (Realloc((void**)&lplu.c_nzlst, m1 * sizeof(NZLST))) ) goto erra;
		lplu.x_sz = m1;  /* sz;  HY020422 */
	}
/* HY020215 add */
#ifdef _DEBUG_SSC
	if(lpdbgf[99]) { /* a~a^~̃`FbN */
		/* ktO̍s̗̈ */
		a = b->bs;
		if( a == NULL ) {  /* VKm */
			if( NULL == (a = (LUMATRX *)malloc( sizeof(LUMATRX) )) ) goto erra;
			memset( a, 0, sizeof(LUMATRX) );
			b->bs = a;
		}
		a->n_col = sz;
		a->n_row = sz;
		x_row = x_col = sz + 1;
		if( a->x_row <= 0 ) {
			if( NULL == (a->row_nz   = (int*)malloc( x_row * sizeof(int) )) ) goto erra;
			if( NULL == (a->row_head = (int*)malloc( x_row * sizeof(int))) ) goto erra;
			a->x_row = x_row;
		} else if( a->x_row < x_row ) {   /* KvΊg */
			if( NULL == (Realloc((void**)&a->row_nz  , x_row * sizeof(int) )) ) goto erra;
			if( NULL == (Realloc((void**)&a->row_head, x_row * sizeof(int))) ) goto erra;
			a->x_row = x_row;
		}
		if( a->x_col <= 0 ) {
			if( NULL == (a->col_nz   = (int*)malloc(x_col * sizeof(int) )) ) goto erra;
			if( NULL == (a->col_head = (int*)malloc(x_col * sizeof(int))) ) goto erra;
			a->x_col = x_col;
		} else if( a->x_col < x_col ) {  /* KvΊg */
			if( NULL == (Realloc((void**)&a->col_nz  , x_col * sizeof(int) )) ) goto erra;
			if( NULL == (Realloc((void**)&a->col_head, x_col * sizeof(int))) ) goto erra;
			a->x_col = x_col;
		}
		/* a->av ̈ HY020625 */
		if( a->x_av <= 0 ) {
			if( NULL == (a->av.i     = (int*)malloc(x_av * sizeof(int) )) ) goto erra;
			if( NULL == (a->av.j     = (int*)malloc(x_av * sizeof(int) )) ) goto erra;
			if( NULL == (a->av.nexti = (int*)malloc(x_av * sizeof(int) )) ) goto erra;
			if( NULL == (a->av.nextj = (int*)malloc(x_av * sizeof(int) )) ) goto erra;
			if( NULL == (a->av.v  = (double*)malloc(x_av * sizeof(double)))) goto erra;
			a->x_av = x_av;
		} else if( a->x_av < x_av ) {  /* KvΊg */
			if( NULL == (Realloc((void**)&a->av.i,    x_av * sizeof(int) )) ) goto erra;
			if( NULL == (Realloc((void**)&a->av.j,    x_av * sizeof(int) )) ) goto erra;
			if( NULL == (Realloc((void**)&a->av.nexti,x_av * sizeof(int) )) ) goto erra;
			if( NULL == (Realloc((void**)&a->av.nextj,x_av * sizeof(int) )) ) goto erra;
			if( NULL == (Realloc((void**)&a->av.v,    x_av * sizeof(double)))) goto erra;
			a->x_av = x_av;
		}
		/* ktO̍s̏ */
		lumx_reset( a );
	}
#endif
	rc = 0;
quit:
#ifdef _DEBUG_SSC
	if(lpdbgf[139])TRACEC(0), Dprintf("lumx_renew rc(%d) \n", rc);
#endif
	return rc;
erra:
	Eprintf( "**** lumx_renew: cannot malloc\n" );
	rc = MALLOC_ERROR; /* ߂l̕ύX 2000.09.28 K.Igarashi */
	goto                                                       quit;
}

/*	ID_lumx_free	P̂kẗ̗̉
/*******************************************************************/
int lumx_free( LUFACT *w_b )
{
	LUFACT   *b = w_b;
	LUMATRX	*a;
	if( b == NULL ) goto                                       quit;
/*	SSCFREE(b->pf    ); */
	SSCFREE(b->br.pfv);
	SSCFREE(b->lw.pfv);
	SSCFREE(b->up.pfv);
	SSCFREE(b->br.aux);
	SSCFREE(b->lw.aux);
	SSCFREE(b->up.aux);
/*	SSCFREE(b->br.pf_aux_head);*/
/*	SSCFREE(b->lw.pf_aux_head);*/
/*	SSCFREE(b->up.pf_aux_head);*/
	SSCFREE(b->ips1  );
	SSCFREE(b->ips2  );
	SSCFREE(b->diag_v);
	/* HY020225 add */
	a = b->bs;
	if( a != NULL ) {
		SSCFREE( a->av.i   );
		SSCFREE( a->av.j   );
		SSCFREE( a->av.nexti   );
		SSCFREE( a->av.nextj   );
		SSCFREE( a->av.v   );
		SSCFREE( a->col_head   );
		SSCFREE( a->row_head   );
		SSCFREE( a->col_nz   );  /* HY020513 */
		SSCFREE( a->row_nz   );  /* HY020513 */
		SSCFREE( b->bs );
	}
	a = b->lu;
	if( a == NULL ) goto                                       quit;
	SSCFREE( a->av.i   );
	SSCFREE( a->av.j   );
	SSCFREE( a->av.nexti   );
	SSCFREE( a->av.nextj   );
	SSCFREE( a->av.v   );
	SSCFREE( a->col_nz     );
	SSCFREE( a->col_head   );
	SSCFREE( a->row_nz     );
	SSCFREE( a->row_head   );
	SSCFREE( a->col_k_head );
	SSCFREE( a->row_k_head );
	SSCFREE(a->rmax_v);
	SSCFREE(a->rmax_f);
	SSCFREE(a->cmax_v);
	SSCFREE(a->cmax_f);
	SSCFREE( b->lu );
quit:
#ifdef _DEBUG_SSC
	if(lpdbgf[140])TRACEB(0), Dprintf("lumx_free \n");
#endif
	return 0;
}
/*	ID_lu_free	Sktʂ̃[N̈̉
/*******************************************************************/
int lu_free(struct lu_work_s *lplu)
{
#ifdef _DEBUG_SSC
	if(lpdbgf[164])TRACEA(0), Dprintf("lu_free \n");
#endif
	SSCFREE( lplu->dwk1    );
	SSCFREE( lplu->dwk2    );
	SSCFREE( lplu->dwk3    );
	SSCFREE( lplu->aibo   );
/*	SSCFREE( lplu->ur      ); /* */
	SSCFREE( lplu->mt      );
	SSCFREE( lplu->ips1 );
	SSCFREE( lplu->ips2 );
	lpvect2_free( &lplu->dalpha );
	lpvect2_free( &lplu->ur );
/*  => HY020529 */
#if defined B3_USE
	SSCFREE( lplu->b3.ms   );
	SSCFREE( lplu->b3.pair );
	SSCFREE( lplu->b3.list1);
	SSCFREE( lplu->b3.list2);
	SSCFREE( lplu->b3.sumi1);
	SSCFREE( lplu->b3.sumi2);
	SSCFREE( lplu->b3.ips1 );
	SSCFREE( lplu->b3.ips2 );
	SSCFREE( lplu->b3.frnd );
#endif //defined B3_USE
/* <= */
	xheap_destroy( &lplu->c_heap );
	xheap_destroy( &lplu->r_heap );
/* HY011217 */
	SSCFREE( lplu->r_nztop );
	SSCFREE( lplu->c_nztop );
	SSCFREE( lplu->r_nzlst );
	SSCFREE( lplu->c_nzlst );
#ifdef _DEBUG_SSC
	if(lpdbgf[164])TRACEC(0), Dprintf("lu_free \n");
#endif
	return 0;
}
/*	ID_lumx_new_av	s̐VvfmۂĂ̔ԍԂ
/*******************************************************************/
static int lumx_new_av( LUMATRX *a )
{
	int		rc, sz;

	if( a->x_av <= 0 ) { /* ŏ͂PUiPmۂ */ CHKA(1, a->x_av, a->x_av);
		sz = 100000;   CHKA(1, a->x_av, -1); /* ɂ͗Ȃ͂ */
		/* mۂP̃̐擪AhXAhXe[uɓ */
		if( NULL == (a->av.i     = (int*)malloc(sz * sizeof(int) ))  ) goto erra;
		if( NULL == (a->av.j     = (int*)malloc(sz * sizeof(int) ))  ) goto erra;
		if( NULL == (a->av.nexti = (int*)malloc(sz * sizeof(int) ))  ) goto erra;
		if( NULL == (a->av.nextj = (int*)malloc(sz * sizeof(int) ))  ) goto erra;
		if( NULL == (a->av.v = (double*)malloc(sz * sizeof(double))) ) goto erra;
		a->x_av = sz;
	} else if( a->n_av >= a->x_av  ) { /* ɂPmۂ */
		sz = a->x_av * 2;
		/* mۂPUiP̃̐擪AhXAhXe[uɓ */
		if( NULL == (Realloc((void**)&a->av.i, sz * sizeof(int)))  ) goto erra;
		if( NULL == (Realloc((void**)&a->av.j, sz * sizeof(int)))  ) goto erra;
		if( NULL == (Realloc((void**)&a->av.nexti, sz * sizeof(int))) ) goto erra;
		if( NULL == (Realloc((void**)&a->av.nextj, sz * sizeof(int))) ) goto erra;
		if( NULL == (Realloc((void**)&a->av.v, sz * sizeof(double)))  ) goto erra;
		a->x_av = sz;
	}
/*	*aav = LUAV( a->av, a->n_av ); */
	/* VvfԍԂAvf𑝂₷ */
	rc = a->n_av++;                    CHKB(1, a->n_av, a->x_av);
quit:
#ifdef _DEBUG_SSC
	if(lpdbgf[141])TRACEB(0), Dprintf("lumx_new_av rc(%d) \n", rc);
#endif
	return rc;
erra:
	Eprintf( "**** lumx_new_av: cannot malloc\n" );
	rc = MALLOC_ERROR; /* ߂l̕ύX 2000.09.28 K.Igarashi */
	goto                                                       quit;
}
/* ID_lumx_only_new_av	s̈vfmۂ̂(lumx_new_av() static ̈ */
/*******************************************************************/
int lumx_only_new_av( LUMATRX *a )
{
	int		rc ;
	/* VvfPm */
	rc = lumx_new_av(a);
	return( rc );
}
/*	ID_lumx_append	s̖ɒǉBsA񋤂ɖǉp
/*******************************************************************/
int lumx_append( LUMATRX *a, int row, int col, double v)
{
	int		rc = -1;
	  
#ifdef _DEBUG_SSC
	if(lpdbgf[142])TRACEA(0), Dprintf("lumx_append row(%d)col(%d)v(%g) \n", row, col, v);
#endif
	if( row < 0 || row >= a->n_row ) { CHKA(0, row, a->n_row); goto quit; }
	if( col < 0 || col >= a->n_col ) { CHKA(0, col, a->n_col); goto quit; }
	if( 0.0 == v ) { CHKX(0.0, 0.0, v); rc = 0; goto    quit; }
	/* VvfPm */
	if( (rc = lumx_new_av(a)) < 0 ) goto          quit;
	a->av.i[rc] = row;
	a->av.j[rc] = col;
	a->av.v[rc] = v;
	++a->col_nz[col];
	++a->row_nz[row];
	++a->num_nz;
	if( v > INFINITE_VALUE || v  < -INFINITE_VALUE ) { CHKA(row, col, 0);
		CHKY(-INFINITE_VALUE, v, INFINITE_VALUE);
	}
	/* 񃊃N̐擪ɒǉ */
	a->av.nexti[rc] = a->col_head[col];
	a->col_head[col] = rc;
	/* sN̐擪ɒǉ */
	a->av.nextj[rc] = a->row_head[row];
	a->row_head[row] = rc;
quit:
#ifdef _DEBUG_SSC
	if(lpdbgf[142])TRACEC(0), Dprintf("lumx_append rc(%d) \n", rc);
#endif
	return rc;
}

/*	ID_lumx_k_append2	ktiksɓ񒼌vf̑OɍɒǉB
/*******************************************************************/
int lumx_k_append2( LUMATRX *a, int row, int col, double v /* int aa*/ ) /* HY011212 ύX */
{
	int		rc = 0;
	int		aa = 0;

#ifdef _DEBUG_SSC
	if(lpdbgf[143])TRACEA(0), Dprintf("lumx_k_append2 row(%d)col(%d)v(%g) \n"
		, row, col, v);
#endif
	if( 0.0 == v ) { CHKX(0.0, 0.0, v); goto                   quit; }
/* lumx_link2()ړ HY011212 ==> */
	/* VvfPm */
	if( (aa = lumx_new_av(a)) < 0 ) goto                 quit;
	a->av.i[aa] = row;
	a->av.j[aa] = col;
	a->av.v[aa] = v;
	++a->col_nz[col];
	++a->row_nz[row];
	++a->num_nz;
/* <== */
	/* sN̍XV */
	a->av.nexti[aa] = a->col_k_head[col];
	a->col_k_head[col] = aa;
	/* 񃊃N̍XV */
	a->av.nextj[aa] = a->row_k_head[row];
	a->row_k_head[row] = aa;
quit:
	rc = aa;
#ifdef _DEBUG_SSC
	if(lpdbgf[143])TRACEC(0), Dprintf("lumx_k_append2 rc(%d) \n", rc);
#endif
	return rc;
}

/*	ID_lumx_k_rm_row_col	ktiksrowscol̍폜B
/*******************************************************************/
int lumx_k_rm_row_col( LUMATRX *a, int row, int col
	,int mode)      /* 1:̃N̂ݍ폜 2:S폜 */
{
	int		aa, nextj, nexti, rc = -1;
	LUAVS	*aav = &a->av; /* aa */

#ifdef _DEBUG_SSC
	if(lpdbgf[144])TRACEA(0), Dprintf("lumx_k_rm_row_col row(%d) \n", row);
#endif
                                      CHKB(2, mode, 2);
	if( mode == 1 ) {
	} else {  /* mode == 2 */
		/* ktiks̓sN̍폜iĚvZj */
		for( aa = a->row_k_head[row]; aa >= 0; aa = nextj ) {
			nextj = aav->nextj[aa];
			aav->nextj[aa] = a->row_head[row];
			a->row_head[row] = aa;
		}
		a->row_k_head[row] = -1;
		/* ktiks̓񃊃N̍폜iĚvZj */
		for( aa = a->col_k_head[col]; aa >= 0; aa = nexti ) {
			nexti = aav->nexti[aa];
			aav->nexti[aa] = a->col_head[col];
			a->col_head[col] = aa;
		}
		a->col_k_head[col] = -1;
	}
	rc = 0;
/*quit:*/
#ifdef _DEBUG_SSC
	if(lpdbgf[144])TRACEC(0), Dprintf("lumx_k_rm_row_col rc(%d) \n", rc);
#endif
	return rc;
}

/*	ID_lumx_mult_mx_d	sƃxNg̊|ZBuo`~ui
/*******************************************************************/
int lumx_mult_mx_d(LUMATRX *a, double *vo, double *vi )
{
	int		col, row, aa;
	LUAVS	*aav;

#ifdef _DEBUG_SSC
	if(lpdbgf[148])TRACEB(0), Dprintf("lumx_mult_mx_d \n");
#endif
	memset( vo, 0, a->n_row*sizeof(double) );
	aav = &a->av;
	for( col = 0; col < a->n_col; ++col ) {
		for( aa = a->col_head[col]; aa >= 0; aa = aav->nexti[aa] ) {
			row = aav->i[aa];
			vo[row] += vi[col] * aav->v[aa];
		}
	}
	return 0;
}
/*	ID_lumx_mult_mx_v2	sƃxNg̊|ZBuo`~ui
/*******************************************************************/
int lumx_mult_mx_v2(LUMATRX *a, double *vo, VECT2 *vi )
{
	int		col, row, aa;
	LUAVS	*aav;

	aav = &a->av;
	memset( vo, 0, a->n_row*sizeof(double) );
	for( col = 0; col < a->n_col; ++col ) {
		if( vi->usef[col] != vi->nowf ) continue;
		for( aa = a->col_head[col]; aa >= 0; aa = aav->nexti[aa] ) {
			row = aav->i[aa];
			vo[row] += vi->va[col] * aav->v[aa];
		}
	}
	return 0;
}

/*	ID_lumx_naiseki_d_a	 zƊsas̓
/*******************************************************************/
static int lumx_naiseki_d_a( LUMATRX *a, int as, double *v1, double *ip )
{
	int		aa, i, rc = 0;
	register double	dwk = 0.0;
	register LUAVS	*aav;
	                                   CHKA(0, as, a->n_col);
#ifdef _DEBUG_SSC
	if(lpdbgf[186])TRACEA(0), Dprintf("lumx_naiseki_d_a ς̌vZ as(%d)\n", as);
	if(lpdbgf[186]>1) { Dprintf("Ł\n"); lumx_dump_col( a, as ); ssc_dump_double(v1, a->n_col, "xNg", 1);}
#endif
	aav = &a->av;
	for( aa = a->col_head[as]; aa >= 0; aa = aav->nexti[aa] ) {
		i = aav->i[aa];
		dwk += v1[i] * aav->v[aa];
	}
	*ip = dwk;
#ifdef _DEBUG_SSC
	if(lpdbgf[186])TRACEC(0), Dprintf("lumx_naiseki_d_a rc(%d) ip(%g)\n", rc, *ip);
#endif
	return rc;
}

/*	ID_lumx_mult_d_mx	sƃxNg̊|ZBuoui~`
/*******************************************************************/
int lumx_mult_d_mx(LUMATRX *a, double *vo, double *vi )
{
	int		col;

#ifdef _DEBUG_SSC
	if(lpdbgf[149])TRACEB(0), Dprintf("lumx_mult_d_mx \n");
#endif
	for( col = 0; col < a->n_col; ++col ) {
		lumx_naiseki_d_a( a, col, vi, &vo[col] );
	}
	return 0;
}

/*	ID_lumx_naiseki_v2_a	 zƊsas̓
/*******************************************************************/
static int lumx_naiseki_v2_a( LUMATRX *a, int as, VECT2 *v1, double *ip )
{
	int		aa, i, rc = 0;
	register double	dwk = 0.0;
	register LUAVS	*aav;
	                                   CHKA(0, as, a->n_col);
	aav = &a->av;
	for( aa = a->col_head[as]; aa >= 0; aa = aav->nexti[aa] ) {
		i = aav->i[aa];
		if( v1->usef[i] == v1->nowf ) 
			dwk += v1->va[i] * aav->v[aa];
	}
	*ip = dwk;
	return rc;
}
/*	ID_lumx_mult_v2_mx	sƃxNg̊|ZBuoui~`
/*******************************************************************/
int lumx_mult_v2_mx(LUMATRX *a, double *vo, VECT2 *vi )
{
	int		col;

	for( col = 0; col < a->n_col; ++col ) {
		lumx_naiseki_v2_a( a, col, vi, &vo[col] );
	}
	return 0;
}
