/*
 * FILE     : xheap.c
 * FUNCTION : zYgq[v֐
 * ALGORITHM:
 * AUTHOR   : H.Yamagiwa  2001.07.02
   SYNOPSIS :
      int rc = xheap_renew( xhp, maxnum, comp )  q[v쐬B
	      rc = -2:s
      int rc = xheap_destroy( xhp )              q[vłāAxhNULLݒ肷
      int rc = xheap_add( xh, idx )             q[vɒǉ
          rc >= 0:q[ṽf[^
	  int rc = xheap_del( xh, idx )             q[v폜
          rc >= 0:q[ṽf[^
	  int rc = xheap_change( xh, idx )          ]lςf[^̈ʒuύX
	  int rc = xheap_top( xh )                  擪f[^܂́|PԂB擪͍폜
	  int rc = xheap_peep( xh )                 擪f[^܂́|PԂBq[v͕ωȂ
	  int rc = xheap_memory( xh )               mۂʂoCgŕԂ

p[^
      int  rc < 0:G[ rc >= 0:
      void **xhp,              io q[vnh
	  int  maxnum             i  őf[^
      int  (*comp)(int, int)  i  f[^r֐Bcomp(x,y)͂Q̓Yf[^x,y͂ƂA
	          ȉ lԂ[U`̊֐łB 
                comp(x,y) < 0  ; x ̒lɎoB
                comp(x,y) > 0  ; y ̒lɎoB
                comp(x,y) = 0  ; ǂł悢B
      void *xh,               i  q[vnh
      int  idx                i  Yf[^ Oidxmaxnum
*/

#include	<stdio.h>
#include	<malloc.h>
#include	<memory.h>
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include	"lp_ssc.h" /*"lpcommon.h"*/

struct xheap {
	int 	rsvnum;            /* mۍσf[^ */
	int 	maxnum;            /* őf[^ */
	int 	usenum;            /* q[vf[^ */
	int 	(*comp)(int, int); /* r֐ */
	int 	*heap;             /* [maxnum]q[v                   invert[]   */
	int 	*invert;           /* [maxnum]q[v̋te[uB heap[]or-1 */
} ;

static struct xheap *pxh = NULL;

/*	ID_xheap_renew	q[v쐬A
/*******************************************************************/
int xheap_renew(               /*    q[v쐬A */
	void	**xh,              /* io q[vnhBlNULLɂĂ */
	int 	maxnum,            /* i  őf[^ */
	int 	(*comp)(int, int)  /* i  r֐ */
)
{
	int		i, size, rc = -2;
	                              CHKB( 1, maxnum, maxnum );
	/* q[vnhm */
	if( *xh == NULL ) {
		*xh = (void*)malloc( sizeof(*pxh) );
		if( *xh == NULL ) goto                                  quit;
		memset( *xh, 0, sizeof(*pxh) );
	}
	pxh = (struct xheap*)*xh;
	size = maxnum * sizeof(int);
	if( pxh->heap == NULL ) {
		pxh->rsvnum = maxnum;
		pxh->heap   = (int*)malloc( size );
		pxh->invert = (int*)malloc( size );
	} else if( pxh->rsvnum < maxnum ) {
		pxh->rsvnum = maxnum;
		if( NULL == Realloc((void**)&pxh->heap,   size ) ) goto erra;
		if( NULL == Realloc((void**)&pxh->invert, size ) ) goto erra;
	}
	if( pxh->heap == NULL || pxh->invert == NULL ) goto         quit;
	pxh->maxnum = maxnum;
	pxh->usenum = 0;
	pxh->comp   = comp;
	for( i = 0; i < maxnum; ++i ) pxh->invert[i] = -1;
	rc = 0;
quit:
	return( rc );
erra:
	Eprintf( "**** lpvect1_alloc: cannot malloc\n" );
//	rc = MALLOC_ERROR; /* ߂l̕ύX 2000.09.28 K.Igarashi */
	rc = -2; /* ߂l̕ύX 2000.09.28 K.Igarashi */
	goto                                                       quit;
}
/*	ID_xheap_destroy	q[vłāAxhNULLݒ肷
/*******************************************************************/
int xheap_destroy(             /*    q[vłāAxhNULLݒ肷 */
	void	**xh               /* io q[vnh */
	)
{
	int		rc = 0;

	if( *xh == NULL ) goto                                      quit;
	pxh = (struct xheap*)*xh;

	SSCFREE( pxh->heap   );
	SSCFREE( pxh->invert );
	SSCFREE( pxh );
	*xh = NULL;
	rc = 0;
quit:	CHKB( 0, rc, 0 );
	return( rc );
}
/*	ID_Xheap_up	擪̃q[vC
/*******************************************************************/
static int Xheap_check()   /*    擪̃q[vC */
{
	int		oy, ko, oyidx, koidx, rc = 0;

	for( ko = pxh->usenum -1; ko > 0; --ko ) {
		oy = ( ko - 1 ) / 2;
		oyidx = pxh->heap[oy];    CHKA( 0, oyidx, pxh->maxnum );
		koidx = pxh->heap[ko];    CHKA( 0, koidx, pxh->maxnum );
		rc = (pxh->comp)( oyidx, koidx );
		if( rc >= 0 )
			CHKA(rc, rc, 0);
	}
	return( 0 );
}

/*	ID_Xheap_up	擪̃q[vC
/*******************************************************************/
static int Xheap_up(   /*    擪̃q[vC */
	int		h,         /* i  ڈʒu pxh->heap[] */
	int		idx        /* i  Yf[^           */
	)
{
	int		oy, ko, oyidx, rc = 0;
                                  CHKA( 0, h, pxh->usenum );
	ko = h;
	while( ko >= 1 ) {
		oy = ( ko - 1 ) / 2;      CHKA( 0, oy, ko );
		oyidx = pxh->heap[oy];    CHKA( 0, oyidx, pxh->maxnum );
		rc = (pxh->comp)( oyidx, idx );
		if( rc < 0 || rc == 0 && oyidx < idx ) break;
		pxh->heap[ko]      = oyidx;
		pxh->invert[oyidx] = ko;
		ko = oy;
	}
	                              CHKB( 0, ko, h );
	pxh->heap[ko]    = idx;       CHKB(-1, pxh->invert[idx], -1 );
	pxh->invert[idx] = ko;
	return( ko );
}
/*	ID_Xheap_down	̃q[vC
/*******************************************************************/
static int Xheap_down( /*    ̃q[vC */
	int		h,         /* i  ڈʒu pxh->heap[] */
	int		idx        /* i  Yf[^           */
	)
{
	int 	oy, ko, koidx, rc = 0;

	oy = h;
	while( ( ko = oy * 2 + 1 ) < pxh->usenum ) {
		if( ko + 1 < pxh->usenum ) {  /* qǂŔr */
			rc = (pxh->comp)( pxh->heap[ko], pxh->heap[ko+1] );
			if( rc > 0 || rc == 0 && pxh->heap[ko] > pxh->heap[ko+1] ) ++ko;
		}
		koidx = pxh->heap[ko];   CHKA( 0, koidx, pxh->maxnum );
		rc = (pxh->comp)( idx, koidx );
		if( rc < 0 || rc == 0 && idx < koidx ) break;
		pxh->heap[oy]      = koidx;
		pxh->invert[koidx] = oy;
		oy = ko;
	}
	                              CHKA( h, oy, pxh->usenum );
	pxh->heap[oy]    = idx;
	pxh->invert[idx] = oy;
	return( oy );
}
/*	ID_xheap_add	q[vɒǉ
/*******************************************************************/
int xheap_add(                 /*    q[vɒǉ */
	void	*xh,               /* i  q[vnh */
	int 	idx                /* i  Yf[^ Oidxmaxnum */
	)
{
	int		h, rc = -1;

	if( xh == NULL ) goto                                       err1;
	pxh = (struct xheap*)xh;
	                                     CHKA( 0, idx, pxh->maxnum );
	if( idx < 0 || idx >= pxh->maxnum ) goto                    quit;
	h = pxh->invert[idx];                CHKB( -1, h, -1 );
	if( h >= 0 ) goto                                           quit;
	/* ǉf[^ŁAŌォ擪Ɍăq[vC */
	rc = Xheap_up( pxh->usenum++, idx ); CHKA( 0, rc, pxh->usenum );
	                                     CHKB( rc, pxh->invert[idx], rc );
	rc = pxh->usenum;  /* f[^ */
/*	Xheap_check(); /* */
quit:
	return( rc );
err1:	CHKB( 0, rc, pxh->usenum );
	goto                                                        quit;
}
/*	ID_xheap_del	q[v폜
/*******************************************************************/
int xheap_del(                 /*    q[v폜 */
	void	*xh,               /* i  q[vnh */
	int 	idx                /* i  Yf[^ Oidxmaxnum */
	)
{
	int		h, i, end, rc = -1;

	if( xh == NULL ) goto                                       err1;
	pxh = (struct xheap*)xh;
	                               CHKA( 0, idx, pxh->maxnum );
	if( idx < 0 || idx >= pxh->maxnum ) goto                    quit;
	                               CHKB( 1, pxh->usenum, pxh->maxnum );
	if( pxh->usenum <= 0 ) goto                                 quit;
	h = pxh->invert[idx];          CHKA( 0, h, pxh->usenum );
	if( h < 0 ) goto                                            quit;
	pxh->invert[idx] = -1;
	 /* Ō̃R[h폜܂̓q[v̍ŏIf[^폜̏ꍇ͏Csv */
	if( (i = --pxh->usenum) > 0 && pxh->heap[i] != idx ) {
		end = pxh->heap[i];        CHKA( 0, end, pxh->maxnum );
		/* ŏIf[^ŁA폜ʒu牺Ƀq[vC */
		rc = Xheap_down( h, end ); CHKA( 0, rc, pxh->usenum );
		                           CHKB( rc, pxh->invert[end], rc );
	}
	rc = pxh->usenum;  /* f[^ */
quit:
	return( rc );
err1:	CHKA( 0, rc, pxh->usenum );
	goto                                                        quit;
}
/*	ID_xheap_change	]lςf[^̈ʒuύX
/*******************************************************************/
int xheap_change(              /*    ]lςf[^̈ʒuύX */
	void	*xh,               /* i  q[vnh */
	int 	idx                /* i  Yf[^ Oidxmaxnum */
	)
{
	int		h, rc = -1;

	if( xh == NULL ) goto                                       err1;
	pxh = (struct xheap*)xh;
	                              CHKA( 0, idx, pxh->maxnum );
	if( idx < 0 || idx >= pxh->maxnum ) goto                    quit;
	                              CHKB( 1, pxh->usenum, pxh->maxnum );
	if( pxh->usenum <= 0 ) goto                                 quit;
	h = pxh->invert[idx];         CHKA( 0, h, pxh->usenum );
	if( h < 0 ) goto                                            quit;
	pxh->invert[idx] = -1;
	/* 擪Ɍăq[vC */
	rc = Xheap_up( h, idx );      CHKB( 0, rc, h );
	if( rc >= h ) {   CHKB( h, rc, h ); /* ύX */
		/* Ɍăq[vC */
		rc = Xheap_down( rc, idx );  CHKA( h, rc, pxh->usenum );
	}
	                              CHKB( rc, pxh->invert[idx], rc );
quit:
	return( rc );
err1:	CHKA( 0, rc, pxh->usenum );
	goto                                                        quit;
}
/*	ID_xheap_top	擪f[^܂́|PԂB擪͍폜
/*******************************************************************/
int xheap_top(                 /* i  擪f[^܂́|PԂB擪͍폜 */
	void	*xh                /* i  q[vnh */
	)
{
	int		i, top, end, rc = -1;

	if( xh == NULL ) goto                                       err1;
	pxh = (struct xheap*)xh;
	if( pxh->usenum <= 0 ) goto                                 quit;
	top = pxh->heap[0];           CHKB(0, pxh->invert[top], 0 );
	pxh->invert[top] = -1;
	if( ( i = --pxh->usenum ) > 0 ) {
		end = pxh->heap[i];       CHKA( 0, end, pxh->maxnum );
		/* ŏIf[^Ő擪牺Ɍăq[vC */
		rc = Xheap_down( 0, end ); CHKA( 0, rc, pxh->usenum );
		                          CHKB( rc, pxh->invert[end], rc );
	}
	rc = top;
/*	Xheap_check(); /* */
quit:
	return( rc );
err1:	CHKA( 0, rc, pxh->maxnum );
	goto                                                        quit;
}
/*	ID_xheap_peep	擪f[^܂́|1ԂBq[v͕ωȂ
/*******************************************************************/
int xheap_peep(                /* i  擪f[^܂́|1ԂBq[v͕ωȂ */
	void	*xh                /* i  q[vnh */
	)
{
	int		rc = -1;

	if( xh == NULL ) goto                                       err1;
	pxh = (struct xheap*)xh;
	if( pxh->usenum > 0 ) rc = pxh->heap[0];
quit:
	return( rc );
err1:	CHKA( 0, rc, pxh->maxnum );
	goto                                                        quit;
}
/*	ID_xheap_memory	mۂʂoCgŕԂ
/*******************************************************************/
int xheap_memory(              /*    mۂʂoCgŕԂ */
	void	*xh,               /* i  q[vnh */
	int		*rsvnum,           /*  o */
	int		*size              /*  o */
	)
{
	int		rc = 0;

	if( xh == NULL ) goto                                       quit;
	pxh = (struct xheap*)xh;
	rc = sizeof(*pxh);
	rc += pxh->rsvnum * sizeof(int) * 2;
	*size = sizeof(int) * 2;
	*rsvnum = pxh->rsvnum;
quit:
	return( rc );
}
/********************************** TEST MAIN ***********************/
#if defined(XHEAP_MAIN)
static int tdat[] = { 3, 9, 5, 7, 8, 4, 1, 2, 6, 0 };
static int	comp( int x, int y )
{
	int		rc;
	rc = tdat[x] - tdat[y];
	if( rc == 0 ) rc = x - y;
	return( rc );
}
static int Xheap_dmp(          /*    q[vnh_v */
	void	*xh                /* i  q[vnh */
	)
{
	int		i, idx, rc = 0;

	if( xh == NULL ) goto                                       quit;
	pxh = (struct xheap*)xh;
	Dprintf( "rsvnum(%d) maxnum(%d) usenum(%d)\n", pxh->rsvnum, pxh->maxnum, pxh->usenum );
	for( i = 0; i < pxh->usenum; ++i ) {
		idx = pxh->heap[i];
		Dprintf( "heap[%d] = %d invert[%d] = %d\n", i, idx, idx, pxh->invert[idx] );
	}
quit:
	return( rc );
}
main()
{
	int		i, size, rc;
	void	*hp1 = NULL, *hp2 = NULL;

	size = sizeof(tdat) / sizeof(tdat[0]);
	rc = xheap_renew( &hp1, size, comp );
	for( i = 0; i < size; ++i ) {
		rc = xheap_add( hp1, i );          CHKB( 1, rc, size );
	}
	rc = xheap_del( hp1, 0 );          CHKB( 0, rc, size );
	rc = xheap_add( hp1, 0 );          CHKB( 1, rc, size );
	rc = xheap_renew( &hp2, size, comp );  CHKB( 0, rc, 0 );
	rc = Xheap_dmp( hp1 );
	do {
		rc = xheap_top( hp1 );             CHKA( -1, rc, size );
	} while( rc >= 0 );
	for( i = 0; i < size; ++i ) {
		rc = xheap_add( hp2, i );          CHKB( 1, rc, size );
	}
	for( i = size -1 ; i >= 0; --i ) {
		rc = xheap_del( hp2, i );          CHKA( 0, rc, size );
	}
	size -= 2;
	rc = xheap_renew( &hp1, size, comp );
	for( i = 0; i < size; ++i ) {
		rc = xheap_add( hp1, i );          CHKB( 1, rc, size );
	}
	tdat[6] = 5;
	rc = xheap_change( hp1, 6 );
	rc = Xheap_dmp( hp1 );
	tdat[1] = 2;
	rc = xheap_change( hp1, 1 );
	rc = Xheap_dmp( hp1 );
	rc = xheap_memory( hp1 );
	rc = xheap_memory( hp2 );
	rc = xheap_destroy( &hp1 );
	rc = xheap_destroy( &hp2 );
	return( rc );
}
#endif